﻿using System;
using MQTTnet.Serializer;

namespace MQTTnet.Client
{
    public interface IMqttClientOptions
    {
        string ClientId { get; }
        bool CleanSession { get; }
        IMqttClientCredentials Credentials { get; }
        MqttProtocolVersion ProtocolVersion { get; }
        IMqttClientChannelOptions ChannelOptions { get; }
        
        TimeSpan CommunicationTimeout { get; }
        TimeSpan KeepAlivePeriod { get; }
        TimeSpan? KeepAliveSendInterval { get; }
        MqttReceivedApplicationMessageProcessingMode ReceivedApplicationMessageProcessingMode { get; }

        MqttApplicationMessage WillMessage { get; }
    }
}